//=====================================================================
//
//	j1FreeRTOS_FreeRTOSConfig.hh - FreeRTOS v8.2.1 made into a PSoC Component
//
//	due to psoc creator's habit of including all .h files into
//	project.h we have made $INSTANCE_NAME_FreeRTOS.h the only
//	.h file. it includes all of the original .h files from the
//	FreeRTOS release as .hh files. each minor change is framed
//	with //>>> and //<<< to make it easy to spot.
//
//	currently we leave all defines, structs, typedefs and
//	function names unchanged. so no $INSTANCE_NAME or $j1LIB_NAME
//	prefixing.
//
//=====================================================================

//=====================================================================
//
// Copyright (c) 2015 Joshua 1 Systems Inc. All rights reserved.
//
// Redistribution and use in source and binary forms, with or without modification, are
// permitted provided that the following conditions are met:
//
//    1. Redistributions of source code must retain the above copyright notice, this list of
//       conditions and the following disclaimer.
//
//    2. Redistributions in binary form must reproduce the above copyright notice, this list
//       of conditions and the following disclaimer in the documentation and/or other materials
//       provided with the distribution.
//
// THIS SOFTWARE IS PROVIDED BY JOSHUA 1 SYSTEMS INC. "AS IS" AND ANY EXPRESS OR IMPLIED
// WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
// FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL <COPYRIGHT HOLDER> OR
// CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
// CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
// SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
// ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
// NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
// ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
//
// The views and conclusions contained in the software and documentation are those of the
// authors and should not be interpreted as representing official policies, either expressed
// or implied, of Joshua 1 Systems Inc.
//
//=====================================================================

/*
    FreeRTOS V8.2.1 - Copyright (C) 2015 Real Time Engineers Ltd.
    All rights reserved

    VISIT http://www.FreeRTOS.org TO ENSURE YOU ARE USING THE LATEST VERSION.

    This file is part of the FreeRTOS distribution.

    FreeRTOS is free software; you can redistribute it and/or modify it under
    the terms of the GNU General Public License (version 2) as published by the
    Free Software Foundation >>!AND MODIFIED BY!<< the FreeRTOS exception.

    ***************************************************************************
    >>!   NOTE: The modification to the GPL is included to allow you to     !<<
    >>!   distribute a combined work that includes FreeRTOS without being   !<<
    >>!   obliged to provide the source code for proprietary components     !<<
    >>!   outside of the FreeRTOS kernel.                                   !<<
    ***************************************************************************

    FreeRTOS is distributed in the hope that it will be useful, but WITHOUT ANY
    WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
    FOR A PARTICULAR PURPOSE.  Full license text is available on the following
    link: http://www.freertos.org/a00114.html

    ***************************************************************************
     *                                                                       *
     *    FreeRTOS provides completely free yet professionally developed,    *
     *    robust, strictly quality controlled, supported, and cross          *
     *    platform software that is more than just the market leader, it     *
     *    is the industry's de facto standard.                               *
     *                                                                       *
     *    Help yourself get started quickly while simultaneously helping     *
     *    to support the FreeRTOS project by purchasing a FreeRTOS           *
     *    tutorial book, reference manual, or both:                          *
     *    http://www.FreeRTOS.org/Documentation                              *
     *                                                                       *
    ***************************************************************************

    http://www.FreeRTOS.org/FAQHelp.html - Having a problem?  Start by reading
    the FAQ page "My application does not run, what could be wrong?".  Have you
    defined configASSERT()?

    http://www.FreeRTOS.org/support - In return for receiving this top quality
    embedded software for free we request you assist our global community by
    participating in the support forum.

    http://www.FreeRTOS.org/training - Investing in training allows your team to
    be as productive as possible as early as possible.  Now you can receive
    FreeRTOS training directly from Richard Barry, CEO of Real Time Engineers
    Ltd, and the world's leading authority on the world's leading RTOS.

    http://www.FreeRTOS.org/plus - A selection of FreeRTOS ecosystem products,
    including FreeRTOS+Trace - an indispensable productivity tool, a DOS
    compatible FAT file system, and our tiny thread aware UDP/IP stack.

    http://www.FreeRTOS.org/labs - Where new FreeRTOS products go to incubate.
    Come and try FreeRTOS+TCP, our new open source TCP/IP stack for FreeRTOS.

    http://www.OpenRTOS.com - Real Time Engineers ltd. license FreeRTOS to High
    Integrity Systems ltd. to sell under the OpenRTOS brand.  Low cost OpenRTOS
    licenses offer ticketed support, indemnification and commercial middleware.

    http://www.SafeRTOS.com - High Integrity Systems also provide a safety
    engineered and independently SIL3 certified version for use in safety and
    mission critical applications that require provable dependability.

    1 tab == 4 spaces!
*/

#ifndef FREERTOS_CONFIG_H
#define FREERTOS_CONFIG_H

/*-----------------------------------------------------------
 * Application specific definitions.
 *
 * These definitions should be adjusted for your particular hardware and
 * application requirements.
 *
 * THESE PARAMETERS ARE DESCRIBED WITHIN THE 'CONFIGURATION' SECTION OF THE
 * FreeRTOS API DOCUMENTATION AVAILABLE ON THE FreeRTOS.org WEB SITE.
 *----------------------------------------------------------*/

//>>>
#include <cyfitter.h>
//<<<

#define configUSE_PREEMPTION		(1)
#define configUSE_IDLE_HOOK			(0)
#define configMAX_PRIORITIES		(5)
#define configUSE_TICK_HOOK			(0)
#define configCPU_CLOCK_HZ			( ( unsigned long ) BCLK__BUS_CLK__HZ )
#define configTICK_RATE_HZ			( ( TickType_t ) (1000) )
#define configMINIMAL_STACK_SIZE	( ( unsigned short ) (100) )
#define configTOTAL_HEAP_SIZE		( ( size_t ) (32768) )
#define configMAX_TASK_NAME_LEN		(12)
#define configUSE_TRACE_FACILITY	(1)
#define configUSE_16_BIT_TICKS		(0)
#define configIDLE_SHOULD_YIELD		(0)
#define configUSE_CO_ROUTINES 		(0)
#define configUSE_MUTEXES			(1)

#define configMAX_CO_ROUTINE_PRIORITIES (2)

#define configUSE_COUNTING_SEMAPHORES 	(1)
#define configUSE_ALTERNATIVE_API 		(0)
#define configCHECK_FOR_STACK_OVERFLOW	(2)
#define configUSE_RECURSIVE_MUTEXES		(1)
#define configQUEUE_REGISTRY_SIZE		(10)
#define configGENERATE_RUN_TIME_STATS	(1)
#define configUSE_MALLOC_FAILED_HOOK	(1)

/* Set the following definitions to 1 to include the API function, or zero
to exclude the API function. */

#define INCLUDE_vTaskPrioritySet			(1)
#define INCLUDE_uxTaskPriorityGet			(1)
#define INCLUDE_vTaskDelete					(1)
#define INCLUDE_vTaskCleanUpResources		(0)
#define INCLUDE_vTaskSuspend				(1)
#define INCLUDE_vTaskDelayUntil				(1)
#define INCLUDE_vTaskDelay					(1)
#define INCLUDE_uxTaskGetStackHighWaterMark	(1)
#define INCLUDE_eTaskGetState				(1)

/**
 * Configure the number of priority bits. This is normally
 * __NVIC_PRIO_BITS but PSoC Creator beta 5 contained a larger
 * value for the priority than is implemented in the hardware so
 * set it here to what the data sheet describes.
 */
#define configPRIO_BITS       (3)        /* 8 priority levels */

/* The lowest priority. */
#define configKERNEL_INTERRUPT_PRIORITY 	( 7 << (8 - configPRIO_BITS) )

/* Priority 5, or 160 as only the top three bits are implemented. */
/* !!!! configMAX_SYSCALL_INTERRUPT_PRIORITY must not be set to zero !!!!
See http://www.FreeRTOS.org/RTOS-Cortex-M3-M4.html. */
#define configMAX_SYSCALL_INTERRUPT_PRIORITY 	( 5 << (8 - configPRIO_BITS) )

//---------------------------------------------------------------------
//	stats counter defines - can use internal or custom
//---------------------------------------------------------------------

#if configGENERATE_RUN_TIME_STATS
	#if (1)
		#define portCONFIGURE_TIMER_FOR_RUN_TIME_STATS	j1FreeRTOS_StatsCounter_Start
		#define portGET_RUN_TIME_COUNTER_VALUE			j1FreeRTOS_StatsCounter_ReadCounter
	#else
		#define portCONFIGURE_TIMER_FOR_RUN_TIME_STATS	
		#define portGET_RUN_TIME_COUNTER_VALUE			
	#endif	// STATS_USE_INTERNAL_TIMER
#endif	// configGENERATE_RUN_TIME_STATS

#endif /* FREERTOS_CONFIG_H */
