//=====================================================================
//
//	j1HY28B.c - j1HY28B c file
//
//=====================================================================

//=====================================================================
//
// Copyright (c) 2015 Joshua 1 Systems Inc. All rights reserved.
//
// Redistribution and use in source and binary forms, with or without modification, are
// permitted provided that the following conditions are met:
//
//    1. Redistributions of source code must retain the above copyright notice, this list of
//       conditions and the following disclaimer.
//
//    2. Redistributions in binary form must reproduce the above copyright notice, this list
//       of conditions and the following disclaimer in the documentation and/or other materials
//       provided with the distribution.
//
// THIS SOFTWARE IS PROVIDED BY JOSHUA 1 SYSTEMS INC. "AS IS" AND ANY EXPRESS OR IMPLIED
// WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
// FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL <COPYRIGHT HOLDER> OR
// CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
// CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
// SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
// ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
// NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
// ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
//
// The views and conclusions contained in the software and documentation are those of the
// authors and should not be interpreted as representing official policies, either expressed
// or implied, of Joshua 1 Systems Inc.
//
//=====================================================================

#include <project.h>

bool	j1HY28B_LCD_StartHelper(j1GFX_CTRL *j1GFX_Ctrl, uint8 displayType, uint8 rotate, uint32 rgb);
bool	j1HY28B_Touch_StartHelper(j1GFX_CTRL *j1GFX_Ctrl, j1HY28B_Touch_CTRL *preload);

//---------------------------------------------------------------------
//	j1HY28B_Start() - init and setup the LCD/Touch interfaces
//---------------------------------------------------------------------

bool j1HY28B_Start(j1HY28B_CTRL *HY28B_Ctrl, j1GFX_CTRL *j1GFX_Ctrl, uint8 dispType, uint8 rotate, uint32_t rgb, j1HY28B_Touch_CTRL *preload)
{
	memset(HY28B_Ctrl, 0, sizeof(j1HY28B_CTRL));
	memset(j1GFX_Ctrl, 0, sizeof(j1GFX_CTRL));
	j1GFX_Ctrl->hardware = HY28B_Ctrl;
	
	if (!j1HY28B_LCD_StartHelper(j1GFX_Ctrl, dispType, rotate, rgb)) return false;

#if j1HY28B_PARAM_TOUCH_SPI_ENABLE
	if (!j1HY28B_Touch_StartHelper(j1GFX_Ctrl, preload)) return false;
#endif
	
	return true;
}
