/*******************************************************************************
* File Name: j1HY28B_iReset.h  
* Version 2.10
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2014, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_j1HY28B_iReset_H) /* Pins j1HY28B_iReset_H */
#define CY_PINS_j1HY28B_iReset_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "j1HY28B_iReset_aliases.h"

/* Check to see if required defines such as CY_PSOC5A are available */
/* They are defined starting with cy_boot v3.0 */
#if !defined (CY_PSOC5A)
    #error Component cy_pins_v2_10 requires cy_boot v3.0 or later
#endif /* (CY_PSOC5A) */

/* APIs are not generated for P15[7:6] */
#if !(CY_PSOC5A &&\
	 j1HY28B_iReset__PORT == 15 && ((j1HY28B_iReset__MASK & 0xC0) != 0))


/***************************************
*        Function Prototypes             
***************************************/    

void    j1HY28B_iReset_Write(uint8 value) ;
void    j1HY28B_iReset_SetDriveMode(uint8 mode) ;
uint8   j1HY28B_iReset_ReadDataReg(void) ;
uint8   j1HY28B_iReset_Read(void) ;
uint8   j1HY28B_iReset_ClearInterrupt(void) ;


/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define j1HY28B_iReset_DM_ALG_HIZ         PIN_DM_ALG_HIZ
#define j1HY28B_iReset_DM_DIG_HIZ         PIN_DM_DIG_HIZ
#define j1HY28B_iReset_DM_RES_UP          PIN_DM_RES_UP
#define j1HY28B_iReset_DM_RES_DWN         PIN_DM_RES_DWN
#define j1HY28B_iReset_DM_OD_LO           PIN_DM_OD_LO
#define j1HY28B_iReset_DM_OD_HI           PIN_DM_OD_HI
#define j1HY28B_iReset_DM_STRONG          PIN_DM_STRONG
#define j1HY28B_iReset_DM_RES_UPDWN       PIN_DM_RES_UPDWN

/* Digital Port Constants */
#define j1HY28B_iReset_MASK               j1HY28B_iReset__MASK
#define j1HY28B_iReset_SHIFT              j1HY28B_iReset__SHIFT
#define j1HY28B_iReset_WIDTH              1u


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define j1HY28B_iReset_PS                     (* (reg8 *) j1HY28B_iReset__PS)
/* Data Register */
#define j1HY28B_iReset_DR                     (* (reg8 *) j1HY28B_iReset__DR)
/* Port Number */
#define j1HY28B_iReset_PRT_NUM                (* (reg8 *) j1HY28B_iReset__PRT) 
/* Connect to Analog Globals */                                                  
#define j1HY28B_iReset_AG                     (* (reg8 *) j1HY28B_iReset__AG)                       
/* Analog MUX bux enable */
#define j1HY28B_iReset_AMUX                   (* (reg8 *) j1HY28B_iReset__AMUX) 
/* Bidirectional Enable */                                                        
#define j1HY28B_iReset_BIE                    (* (reg8 *) j1HY28B_iReset__BIE)
/* Bit-mask for Aliased Register Access */
#define j1HY28B_iReset_BIT_MASK               (* (reg8 *) j1HY28B_iReset__BIT_MASK)
/* Bypass Enable */
#define j1HY28B_iReset_BYP                    (* (reg8 *) j1HY28B_iReset__BYP)
/* Port wide control signals */                                                   
#define j1HY28B_iReset_CTL                    (* (reg8 *) j1HY28B_iReset__CTL)
/* Drive Modes */
#define j1HY28B_iReset_DM0                    (* (reg8 *) j1HY28B_iReset__DM0) 
#define j1HY28B_iReset_DM1                    (* (reg8 *) j1HY28B_iReset__DM1)
#define j1HY28B_iReset_DM2                    (* (reg8 *) j1HY28B_iReset__DM2) 
/* Input Buffer Disable Override */
#define j1HY28B_iReset_INP_DIS                (* (reg8 *) j1HY28B_iReset__INP_DIS)
/* LCD Common or Segment Drive */
#define j1HY28B_iReset_LCD_COM_SEG            (* (reg8 *) j1HY28B_iReset__LCD_COM_SEG)
/* Enable Segment LCD */
#define j1HY28B_iReset_LCD_EN                 (* (reg8 *) j1HY28B_iReset__LCD_EN)
/* Slew Rate Control */
#define j1HY28B_iReset_SLW                    (* (reg8 *) j1HY28B_iReset__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define j1HY28B_iReset_PRTDSI__CAPS_SEL       (* (reg8 *) j1HY28B_iReset__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define j1HY28B_iReset_PRTDSI__DBL_SYNC_IN    (* (reg8 *) j1HY28B_iReset__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define j1HY28B_iReset_PRTDSI__OE_SEL0        (* (reg8 *) j1HY28B_iReset__PRTDSI__OE_SEL0) 
#define j1HY28B_iReset_PRTDSI__OE_SEL1        (* (reg8 *) j1HY28B_iReset__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define j1HY28B_iReset_PRTDSI__OUT_SEL0       (* (reg8 *) j1HY28B_iReset__PRTDSI__OUT_SEL0) 
#define j1HY28B_iReset_PRTDSI__OUT_SEL1       (* (reg8 *) j1HY28B_iReset__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define j1HY28B_iReset_PRTDSI__SYNC_OUT       (* (reg8 *) j1HY28B_iReset__PRTDSI__SYNC_OUT) 


#if defined(j1HY28B_iReset__INTSTAT)  /* Interrupt Registers */

    #define j1HY28B_iReset_INTSTAT                (* (reg8 *) j1HY28B_iReset__INTSTAT)
    #define j1HY28B_iReset_SNAP                   (* (reg8 *) j1HY28B_iReset__SNAP)

#endif /* Interrupt Registers */

#endif /* CY_PSOC5A... */

#endif /*  CY_PINS_j1HY28B_iReset_H */


/* [] END OF FILE */
