//=====================================================================
//
//	TaskStats.c - testing task stats
//
//=====================================================================

#include "main.h"

void qsort(void *base, size_t num_members, size_t size, int (*compare_function) (const void *, const void *));

#define	TASK_NO	4
#define REGX	0
#define REGY	36
#define	REGW	(HY28B_j1GFX_Ctrl.displayWidth)
#define	REGH	(HY28B_j1GFX_Ctrl.displayHeight - REGY)
#define	BG_RGB	0x000000
#define	FG_RGB	0xffffff

//---------------------------------------------------------------------
//	TaskStats() - entry point
//---------------------------------------------------------------------

int xTaskStatusTypeCmpFunc (const void * a, const void * b)
{
   return ( ((TaskStatus_t *) a)->xTaskNumber - ((TaskStatus_t *) b)->xTaskNumber );
}

void TaskStats(void *pvParameters)
{
	j1Put_CTRL	j1Put_Ctrl;
	j1GFX_CTRL	j1GFX_Ctrl;
	
	unsigned portBASE_TYPE	i, taskCnt, taskStatusCnt;
//	int						nameSize;
	TaskStatus_t			*tstPtr;
	uint16					wanker;
	unsigned long			totalRunTime, pctDivisor, taskPct;
	char					pctBfr[4];
	
	
//	vTaskDelay(1000 / portTICK_RATE_MS);

//	taskENTER_CRITICAL();
//	LCD_Position(1,0);
//	LCD_PrintString("Stats           ");
//	taskEXIT_CRITICAL();
	
	j1Put_Ctrl.Put_Char		= (void *) j1GFX_PutChar;
	j1Put_Ctrl.deviceCtrl 	= &j1GFX_Ctrl;
	
	Mutexes_j1GFX(true);
	j1GFX_SetRegion(&HY28B_j1GFX_Ctrl, &j1GFX_Ctrl, REGX, REGY, REGW, REGH);
	j1GFX_FillRegion(&j1GFX_Ctrl, BG_RGB);
	j1GFX_DrawRect(&j1GFX_Ctrl, 0, 0, j1GFX_Ctrl.regWidth    , j1GFX_Ctrl.regHeight    , 0xff0000);
	j1GFX_DrawRect(&j1GFX_Ctrl, 1, 1, j1GFX_Ctrl.regWidth - 2, j1GFX_Ctrl.regHeight - 2, 0x00ff00);
	j1GFX_DrawRect(&j1GFX_Ctrl, 2, 2, j1GFX_Ctrl.regWidth - 4, j1GFX_Ctrl.regHeight - 4, 0x0000ff);
	j1GFX_SetRegion(NULL, &j1GFX_Ctrl, j1GFX_Ctrl.regOffsetX + 3, j1GFX_Ctrl.regOffsetY + 3, j1GFX_Ctrl.regWidth - 6, j1GFX_Ctrl.regHeight - 6);
	j1GFX_SetFontFgBg(&j1GFX_Ctrl, j1GFX_FONT_5X7, 1, FG_RGB, BG_RGB);
//	j1GFX_SetTextRowCol(&j1GFX_Ctrl, 0, 0);
//	j1GFX_PutChar(&j1GFX_Ctrl, TASK_NO + '0');
	Mutexes_j1GFX(false);
	
	wanker = 0;
	
	while (true)
	{
//		CyPins_ClearPin(LED3_0);
		vTaskDelay(10000 / portTICK_PERIOD_MS);
		
		wanker++;
		
//		j1GFX_FillRegion(&j1GFX_Ctrl, ((wanker & 0xf) << 20) | ((wanker & 0xf) << 12) | ((wanker & 0xf) << 4));

		taskCnt = uxTaskGetNumberOfTasks();
		
		if (taskCnt > taskCreateTableSize + 1)
		{
//			taskENTER_CRITICAL();
//			LCD_Position(1,0);
//			LCD_PrintString("Stats-Fail Cnt  ");
//			taskEXIT_CRITICAL();
			
			vTaskSuspend(NULL);
		}
		
		taskStatusCnt = uxTaskGetSystemState(taskStatusTable, taskCreateTableSize + 1, &totalRunTime );
		
		if (taskStatusCnt != taskCnt)
		{
//			taskENTER_CRITICAL();
//			LCD_Position(1,0);
//			LCD_PrintString("Stats-Fail Get  ");
//			taskEXIT_CRITICAL();
			
			vTaskSuspend(NULL);
		}
		
		qsort(taskStatusTable, taskStatusCnt, sizeof(taskStatusTable[0]), xTaskStatusTypeCmpFunc);
		
		Mutexes_j1GFX(true);
		j1GFX_SetTextRowCol(&j1GFX_Ctrl, 0, 0);
//		j1Put_Hex32(&j1Put_Ctrl, StatsCount_Read(), 0);
		j1Put_Hex32(&j1Put_Ctrl, upTimeSecs, 0);
		j1Put_Char(&j1Put_Ctrl, ' ');
		j1Put_Hex32(&j1Put_Ctrl, j1FreeRTOS_StatsCounter_ReadCounter(), 0);
		Mutexes_j1GFX(false);
		
		pctDivisor = totalRunTime / 1000ul;
		
		for (i = 0, tstPtr = taskStatusTable; i < taskStatusCnt; i++, tstPtr++)
		{
//			taskENTER_CRITICAL();
//			LCD_Position(1,0);
//			LCD_PrintHexUint8(i);
//			LCD_PutChar(' ');
//			LCD_PrintString((char *) tstPtr->pcTaskName);
//			nameSize = strlen((char *) tstPtr->pcTaskName);
//			while (nameSize < 5) { LCD_PutChar(' '); nameSize++; } 
//			LCD_PutChar(' ');
//			LCD_PrintHexUint8(tstPtr->uxCurrentPriority);
//			LCD_PutChar(' ');
//			LCD_PrintHexUint16(tstPtr->usStackHighWaterMark);
//			LCD_PrintHexUint16((uint32) tstPtr->xHandle >> 16);
//			LCD_PrintHexUint16((uint32) tstPtr->xHandle & 0xffff);
//			taskEXIT_CRITICAL();

//			vTaskDelay(2500 / portTICK_RATE_MS);
			
			if (pctDivisor) taskPct = tstPtr->ulRunTimeCounter / pctDivisor;
					   else taskPct = 0;
			
			if (taskPct > 999) taskPct = 999;
			
			pctBfr[0] = taskPct / 100 + '0';
			if (pctBfr[0] == '0') pctBfr[0] = ' ';
			taskPct %= 100;
			pctBfr[1] = taskPct /  10 + '0';
			taskPct %= 10;
			pctBfr[2] = '.';
			pctBfr[3] = taskPct + '0';
			
			Mutexes_j1GFX(true);
			j1GFX_SetTextRowCol(&j1GFX_Ctrl, i+1, 0);
			j1Put_Char(&j1Put_Ctrl, i + '0');
			j1Put_Char(&j1Put_Ctrl, ' ');
			j1Put_StringField(&j1Put_Ctrl, (char *) tstPtr->pcTaskName, configMAX_TASK_NAME_LEN - 1, 0);
			j1Put_Char(&j1Put_Ctrl, ' ');
			j1Put_Hex8(&j1Put_Ctrl, tstPtr->uxCurrentPriority, 0);
			j1Put_Char(&j1Put_Ctrl, ' ');
			j1Put_Hex16(&j1Put_Ctrl, tstPtr->usStackHighWaterMark, 0);
			j1Put_Char(&j1Put_Ctrl, ' ');
//			j1PutHex16(&j1Put_Ctrl, wanker, 0);
//			j1GFX_SetTextRowCol(&j1GFX_Ctrl, 2 * i + 2, 2);
//			j1PutHex32(&j1Put_Ctrl, (uint32) tstPtr->xHandle, 0);
//			j1PutChar(&j1Put_Ctrl, ' ');
			j1Put_Hex32(&j1Put_Ctrl, (uint32) tstPtr->ulRunTimeCounter, 0);
			j1Put_Char(&j1Put_Ctrl, ' ');
			j1Put_Field(&j1Put_Ctrl, pctBfr, sizeof(pctBfr), 0);
			j1Put_Char(&j1Put_Ctrl, '%');
			Mutexes_j1GFX(false);
		}
	}
}
