//=====================================================================
//
//	main.h - central header file
//
//=====================================================================

#if !defined(MAIN_H)
#define MAIN_H
	
//---------------------------------------------------------------------
//	GLOBALQUALIFY defines
//---------------------------------------------------------------------
	
#if !defined(THIS_IS_MAIN_APPLICATION)
	#define	GLOBALQUALIFY	extern
#else
	#define	GLOBALQUALIFY
#endif
	
//---------------------------------------------------------------------
//	project.h - use everything in the project
//---------------------------------------------------------------------
	
#include <project.h>

//---------------------------------------------------------------------
//	stdlib includes
//---------------------------------------------------------------------

#include <stdbool.h>

//---------------------------------------------------------------------
//	support includes
//---------------------------------------------------------------------

#include "Mutexes.h"
	
//---------------------------------------------------------------------
//	task includes
//---------------------------------------------------------------------
	
#include "Task1Sec.h"
#include "Task1.h"
#include "Task2.h"
#include "Task3.h"
#include "TaskStats.h"

//---------------------------------------------------------------------
//	task tables
//---------------------------------------------------------------------

typedef	struct	_TASK_CREATE_TABLE
{
	const TaskFunction_t			pvTaskCode;
	const char						cTaskName[configMAX_TASK_NAME_LEN];
	const unsigned short			usStackDepth;
	const void						*pvParameters;
	const unsigned portBASE_TYPE	uxPriority;
} TASK_CREATE_TABLE;

#if defined(THIS_IS_MAIN_APPLICATION)
	GLOBALQUALIFY	TASK_CREATE_TABLE	const taskCreateTable[] = {
		{ Task1Sec , "1Sec" , 128, NULL, 1 },
		{ Task1    , "Task1", 128, NULL, 1 },
		{ Task2    , "Task2", 128, NULL, 1 },
		{ Task3    , "Task3", 128, NULL, 1 },
		{ TaskStats, "Stats", 128, NULL, 1 }
	};

	#define	TASK_CREATE_TABLE_SIZE	(sizeof(taskCreateTable) / sizeof(taskCreateTable[0]))
	GLOBALQUALIFY	const unsigned portBASE_TYPE	taskCreateTableSize = TASK_CREATE_TABLE_SIZE;
	GLOBALQUALIFY	TaskHandle_t		taskHandleTable[TASK_CREATE_TABLE_SIZE];
	GLOBALQUALIFY	TaskStatus_t		taskStatusTable[TASK_CREATE_TABLE_SIZE + 1];

#else
	GLOBALQUALIFY	TASK_CREATE_TABLE	const taskCreateTable[];
	GLOBALQUALIFY	const unsigned portBASE_TYPE	taskCreateTableSize;
	GLOBALQUALIFY	TaskHandle_t		taskHandleTable[];
	GLOBALQUALIFY	TaskStatus_t		taskStatusTable[];
#endif

//---------------------------------------------------------------------
//	j1GFX control area
//---------------------------------------------------------------------

GLOBALQUALIFY j1GFX_CTRL		HY28B_j1GFX_Ctrl;
GLOBALQUALIFY j1HY28B_CTRL		HY28B_Ctrl;


//---------------------------------------------------------------------
//	global time data
//---------------------------------------------------------------------

GLOBALQUALIFY	uint32	upTimeSecs;		// seconds since start-up

//---------------------------------------------------------------------
//	function prototypes
//---------------------------------------------------------------------

void	StatsCount_Start();
uint32	StatsCount_Read();

#endif	// MAIN_H
